//+------------------------------------------------------------------+
//|                                                   ema_cross.mq4 |
//|                                  Copyright  2008, eadeveloper |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, eadeveloper"
#property link      "forex.trading@gmx.at"

extern int MagicN=200000;
extern int RSI=14;
extern int EMA_fast=7;
extern int EMA_slow=15;
extern int EMA_trend=90;
extern int MinMarginLevel=200;
extern int MinFreeMargin=70;
extern double Lot=15;

extern int TP=300;
extern int SL=100;
extern int TrailingStop=25;
extern int TrailingStep=5;
extern int Balance_Percent=25;

int ticket;

double calclot;




static int          prevtime = 0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

MagicN = MagicN+ Period();


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   
int hasbuy=0;
int hassell=0;
double Profit=0;
double BuyProfit=0;
double SellProfit=0;
double CP=0;

for(int i = 0; i < OrdersTotal(); i++) 
      {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if(OrderSymbol() == Symbol()&&OrderMagicNumber() == MagicN)
       {
       
       if (OrderType()==OP_BUY) 
       {
       hasbuy++;
       CP=CP+((Bid-OrderOpenPrice())/Point);
       if (TrailingStop>0&&Bid-OrderOpenPrice() > TrailingStop*Point) 
         {
         if (OrderStopLoss() < Bid-(TrailingStop+TrailingStep-1)*Point || OrderStopLoss() == 0) 
            {
            OrderModify(OrderTicket(), OrderOpenPrice(), Bid-TrailingStop*Point, OrderTakeProfit(), 0, Blue);
            }
         }
       }
       if (OrderType()==OP_SELL)
       {
       hassell++;
       CP=CP+((OrderOpenPrice()-Ask)/Point);
       if (TrailingStop>0&&OrderOpenPrice()-Ask > TrailingStop*Point) 
       {
        if (OrderStopLoss() > Ask+(TrailingStop+TrailingStep-1)*Point || OrderStopLoss() == 0) 
        {
          OrderModify(OrderTicket(), OrderOpenPrice(), Ask+TrailingStop*Point, OrderTakeProfit(), 0, Blue);
        }
     }
       }
       }
       }//for (i=0..
       
if (TP>0&&CP>TP)
{
   Print("Close Orders by Profit");
   if (BuyProfit>SellProfit)
      {CloseAllBuy();CloseAllSell();}
      else
      {CloseAllSell();CloseAllBuy();}
}

int aktion=0;


double ATR=iATR(Symbol(),0,14,1);
double mRSI=iRSI(Symbol(),0,RSI,PRICE_CLOSE,1);
double ma_f_1=iMA(Symbol(),0,EMA_fast,0,MODE_EMA,PRICE_CLOSE,1);
double ma_f_2=iMA(Symbol(),0,EMA_fast,0,MODE_EMA,PRICE_CLOSE,2);
double ma_s_1=iMA(Symbol(),0,EMA_slow,0,MODE_EMA,PRICE_CLOSE,1);
double ma_s_2=iMA(Symbol(),0,EMA_slow,0,MODE_EMA,PRICE_CLOSE,2);
double ma_t_1=iMA(Symbol(),0,EMA_trend,0,MODE_EMA,PRICE_CLOSE,1);

if (ma_f_1>ma_s_1 && ma_f_2<=ma_s_2 &&ma_s_1>ma_t_1&&mRSI>50)
   {
         aktion=1;
      }

//RSI>30&&HLm<=HlmLast&&&&HLC<HLm
if (ma_f_1<ma_s_1 && ma_f_2>=ma_s_2 &&ma_s_1<ma_t_1&&mRSI<50)
   {
   
      aktion=-1;
      }

if (hasbuy>0 && aktion==-1)
   {
   CloseAllBuy();
   //openorders=openorders-hasbuy;
   }
   
if (hassell>0 && aktion==1)
   {
   CloseAllSell();
   //openorders=openorders-hassell;
   }
   
if (Time[0] == prevtime) return(0);
   prevtime = Time[0];
   
if (AccountFreeMargin()<MinFreeMargin)
   {
   Comment("Zu wenig Free Margin: "+ AccountFreeMargin() +"!)");
   return(0);
   }
   
if (!IsDemo()&&AccountMargin()>0)
{
if((AccountEquity()/AccountMargin())*100<MinMarginLevel) 
     {
       Comment("MarginLevel nicht ausreichend fr neue Order: "+(AccountEquity()/AccountMargin())*100);
       return(0);
     }       
}


//
calclot=LotsOptimized(Lot,1);
if (aktion==1)
   {
   if (CheckBuyMargin()) 
   {
      OpenOrder("Buy",5,calclot,3,TP,SL+ATR/Point,MagicN,"EA");
      //OpenOrder("Buy",5,calclot,3,TP+1,SL+ATR/Point,MagicN,"EA");
      //OpenOrder("Buy",5,calclot,3,TP+2,SL+ATR/Point,MagicN,"EA");
      //OpenOrder("Buy",5,calclot,3,TP*4,SL+ATR/Point,MagicN,"EA");
      }
          
   }
// 
if (aktion==-1)
   {
   if (CheckSellMargin()) 
   {
      OpenOrder("Sell",5,calclot,3,TP,SL+ATR/Point,MagicN,"EA");  
      //OpenOrder("Sell",5,calclot,3,TP+1,SL+ATR/Point,MagicN,"EA"); 
      //OpenOrder("Sell",5,calclot,3,TP+2,SL+ATR/Point,MagicN,"EA"); 
      //OpenOrder("Sell",5,calclot,3,TP*4,SL+ATR/Point,MagicN,"EA"); 
      }   
   
   }

   

//----
   return(0);
  }
//+------------------------------------------------------------------+

int OpenOrder(string OrderArt,int versuche,double VOLUME,int SLIPPAGE,int T_P,int S_L,int M_N,string Hint)
{
double ask,bid;
double STOP_LOSS,TAKE_PROFIT;
int ticket = -1;
int v=0;
while(ticket < 0 &&v<versuche) //Keep trying till order goes through
{
RefreshRates();
ask = Ask;
bid = Bid;
if (IsTradeAllowed())
{
if(OrderArt=="Buy")
{

if (S_L>0)STOP_LOSS=ask-(S_L*Point);else STOP_LOSS=0;
if (T_P>0)TAKE_PROFIT=ask+(T_P*Point);else TAKE_PROFIT=0;
ticket = OrderSend(Symbol(),OP_BUY,VOLUME,ask,SLIPPAGE,STOP_LOSS,TAKE_PROFIT,Hint,M_N,0,Blue);
}
else
{

if (S_L>0)STOP_LOSS=bid+(S_L*Point);else STOP_LOSS=0;
if (T_P>0)TAKE_PROFIT=bid-(T_P*Point);else TAKE_PROFIT=0;
ticket = OrderSend(Symbol(),OP_SELL,VOLUME,bid,SLIPPAGE,STOP_LOSS,TAKE_PROFIT,Hint,M_N,0,Red); 
}
}
if(ticket < 0)
{
Print("OrderSend failed with error #",GetLastError());
Sleep(1000);
}
v++;
}
return(ticket);
}


void CloseAllBuy() 
{ 
 for (int d = 3 ; d >= 0; d--) 
  {
  for (int cnt = OrdersTotal()-1 ; cnt >= 0; cnt--) 
  { 
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES); 
    if (OrderType()==OP_BUY&&OrderSymbol() == Symbol()) 
    {         
        if(OrderMagicNumber() == MagicN) 
          { RefreshRates();
          OrderClose(OrderTicket(),OrderLots(),Bid,3,CLR_NONE);
          Sleep(500);
          }
    } 
  } 
  }
}

void CloseAllSell() 
{ 
   for (int d = 3 ; d >= 0; d--) 
  { 
  for (int cnt = OrdersTotal()-1 ; cnt >= 0; cnt--) 
  { 
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES); 
    if (OrderType()==OP_SELL&&OrderSymbol() == Symbol()) 
    {         
        if(OrderMagicNumber() == MagicN) 
        {
        RefreshRates();
          OrderClose(OrderTicket(),OrderLots(),Ask,3,CLR_NONE);
          Sleep(100);
        }
    } 
  } 
 }
}

double LotsOptimized(double Lots,int MaximumRisk)
  {
   double lot=Lots;
   int komma;
   
   if (NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT),2)==0.01) komma=2;else komma=1; 
   double e=AccountEquity()/100*Balance_Percent;
   lot=NormalizeDouble(e*MaximumRisk/10000.0,komma);
   
   if(lot<0.01) lot=0.01;
   if (lot>Lots) lot=Lots;
   return(lot);
  }
  

bool CheckBuyMargin()
{
double cm=AccountFreeMarginCheck(Symbol(),OP_BUY,calclot);
if (cm>MinFreeMargin)
return(true);
else
return(false);
}

bool CheckSellMargin()
{
double cm=AccountFreeMarginCheck(Symbol(),OP_SELL,calclot);
if (cm>MinFreeMargin)
return(true);
else
return(false);
}